// Spanish translation by:
// Leandro Lucarella <leandro at lucarella.com.ar>,
// Jess Climent <jesus.climent at hispalinux.es>,
// Sefanja Ruijsenaars <sefanja at gmx.net>
// Andoni Zubimendi <andoni at lpsat.net>

// Updated to help_mp-en.h v1.95

// ========================= MPlayer help ===========================


#ifdef HELP_MP_DEFINE_STATIC
static char help_text[]=
"Uso:   mplayer [opciones] [url o ruta del archivo]\n"
"\n"
"Opciones bsicas: ('man mplayer' para una lista completa)\n"
" -vo <driver[:disp]>  Seleccionar driver de salida de vdeo y dispositivo ('-vo help' para obtener una lista).\n"
" -ao <driver[:disp]>  Seleccionar driver de salida de audio y dispositivo ('-ao help' para obtener una lista).\n"
" -vcd <numpista>      Reproducir pista de VCD (Video CD) desde un dispositivo en vez de un archivo regular.\n"
#ifdef HAVE_LIBCSS
" -dvdauth <disp>      Especificar dispositivo DVD para autenticacin (para discos encriptados).\n"
#endif
#ifdef USE_DVDREAD
" -dvd <nmero>        Reproducir ttulo o pista de DVD desde un dispositivo en vez de un archivo regular.\n"
" -alang <lengua>      Seleccionar lengua para el audio del DVD (con cdigo de pas de dos caracteres. p. ej. 'es').\n"
" -alang <lengua>      Seleccionar lengua para los subttulos del DVD.\n"
#endif
" -ss <tiempo>         Saltar a una posicin determindada (en segundos o hh:mm:ss).\n"
" -nosound             No reproducir sonido.\n"
" -fs, -vm, -zoom      Opciones de pantalla completa (pantalla completa, cambio de modo de vdeo, escalado por software).\n"
" -x <x> -y <y>        Escalar imagen a resolucin dada (para usar con -vm o -zoom).\n"
" -sub <archivo>       Especificar archivo de subtitulos a usar (mira tambin -subfps, -subdelay).\n"
" -playlist <archivo>  Especificar archivo con la lista de reproduccin.\n"
" -vid <x> -aid <y>    Opciones para especificar el stream de vdeo (x) y de audio (y) a reproducir.\n"
" -fps <x> -srate <y>  Opciones para cambiar la tasa de vdeo (x fps) y de audio (y Hz).\n"
" -pp <calidad>        Activar filtro de postprocesado (lee la pgina man para ms informacin).\n"
" -framedrop           Activar frame dropping (para mquinas lentas).\n\n"

"Teclas bsicas ('man mplayer' para una lista completa, mira tambin input.conf):\n"
" <-    ->       Avanzar o retroceder diez segundos.\n"
" arriba  abajo  Avanzar o retroceder un minuto.\n"
" pgup  pgdown   Avanzar o retroceder diez minutos.\n"
" <  >           Avanzar o retroceder en la lista de reproduccin.\n"
" p  ESPACIO     Pausar el vdeo (presione cualquier tecla para continuar).\n"
" q  ESC         Detener la reproduccin y salir del programa.\n"
" +  -           Ajustar el retardo de audio en ms o menos 0.1 segundos.\n"
" o               Cambiar modo OSD:  nada / bsqueda / bsqueda y tiempo.\n"
" *  /           Aumentar o disminuir el volumen (presione 'm' para elegir entre master/pcm).\n"
" z  x           Ajustar el retardo de la subttulacin en ms o menos 0.1 segundos.\n"
" r  t           Ajustar posicin de la subttulacin (mira tambin -vop expand).\n"
"\n"
" *** Lee la pgina man para ms opciones (avanzadas) y teclas! ***\n"
"\n";
#endif

// ========================= MPlayer messages ===========================

// mplayer.c: 

#define MSGTR_Exiting "\nSaliendo... (%s)\n"
#define MSGTR_Exit_quit "Salida."
#define MSGTR_Exit_eof "Fin del archivo."
#define MSGTR_Exit_error "Error fatal."
#define MSGTR_IntBySignal "\nMPlayer ha sido interrumpido por seal %d en el mdulo: %s \n"
#define MSGTR_NoHomeDir "No se puede encontrar el directorio HOME.\n"
#define MSGTR_GetpathProblem "Problema en get_path(\"config\").\n"
#define MSGTR_CreatingCfgFile "Creando archivo de configuracin: %s.\n"
#define MSGTR_InvalidVOdriver "Nombre del driver de salida de vdeo incorrecto: %s\nUsa '-vo help' para obtener la lista de drivers de salida de vdeo disponibles.\n"
#define MSGTR_InvalidAOdriver "Nombre del driver de salida de audio incorrecto: %s\nUsa '-ao help' para obtener la lista de drivers de salida de audio disponibles.\n"
#define MSGTR_CopyCodecsConf "Copia o enlaza <rbol del cdigo fuente de MPlayer>/etc/codecs.conf a ~/.mplayer/codecs.conf\n"
#define MSGTR_BuiltinCodecsConf "Usando codecs.conf interno por defecto.\n" 
#define MSGTR_CantLoadFont "No se puede cargar fuente: %s.\n"
#define MSGTR_CantLoadSub "No se puede cargar la subttulacin: %s.\n"
#define MSGTR_ErrorDVDkey "Error procesando la clave del DVD.\n"
#define MSGTR_CmdlineDVDkey "Se usar la clave DVD solicitada para la descodificacin.\n"
#define MSGTR_DVDauthOk "La secuencia de autorizacin del DVD parece estar bien.\n"
#define MSGTR_DumpSelectedStreamMissing "Dump: no se encuentra el stream seleccionado.\n"
#define MSGTR_CantOpenDumpfile "No se puede abrir el archivo de dump.\n"
#define MSGTR_CoreDumped "Core dumped.\n"
#define MSGTR_FPSnotspecified "FPS no especificado (o invlido) en la cabecera! Usa la opcin -fps.\n"
#define MSGTR_TryForceAudioFmtStr "Tratando de forzar la familia del codec de audio %d...\n"
#define MSGTR_CantFindAfmtFallback "No se encuentra codec de audio para la familia forzada, se usarn otros drivers.\n"
#define MSGTR_CantFindAudioCodec "No se encuentra codec para el formato de audio 0x%X!\n"
#define MSGTR_TryUpgradeCodecsConfOrRTFM "*** Intenta actualizar %s en etc/codecs.conf\n*** Si todava no funciona, lee DOCS/codecs.html!\n"
#define MSGTR_CouldntInitAudioCodec "No se pudo inicializar el codec de audio, no se reproducir sonido!\n"
#define MSGTR_TryForceVideoFmtStr "Tratando de forzar la familia del codec de vdeo %d ...\n"
#define MSGTR_CantFindVideoCodec "No se encuentra codec para el formato de vdeo 0x%X!\n"
#define MSGTR_VOincompCodec "Disculpe, el dispositivo de salida de vdeo es incompatible con este codec.\n"
#define MSGTR_CannotInitVO "FATAL: No se puede inicializar el driver de vdeo!\n"
#define MSGTR_CannotInitAO "No se puede abrir o inicializar dispositivo de audio, no se reproducir sonido.\n"
#define MSGTR_StartPlaying "Empezando reproduccin...\n"

#define MSGTR_SystemTooSlow "\n\n"\
"       **************************************************************\n"\
"       **** Tu sistema es demasiado lento para reproducir esto!  ****\n"\
"       **************************************************************\n"\
"Posibles razones, problemas, soluciones: \n"\
"- Ms comn: driver de _audio_ con errores. Solucin: intenta -ao sdl, o usa\n"\
"  ALSA 0.5 o la emulacin OSS de ALSA 0.9. Lee DOCS/sound.html para ms informacin.\n"\
"- Salida de vdeo lenta: prueba otro driver -vo (para obtener una lista, -vo help) o\n"\
"  intenta iniciar con la opcin -framedrop. Lee DOCS/video.html para ms sugerencias.\n"\
"- CPU lenta: no reproduzcas DVD o DivX grandes en una CPU lenta. Intenta iniciar con\n"\
"  la opcin -hardframedrop.\n"\
"- Archivo errneo: prueba combinaciones de: -nobps, -ni, -mc 0, -forceidx\n"\
"  Si ninguna funciona, lee DOCS/bugreports.html\n\n"

#define MSGTR_NoGui "MPlayer fue compilado sin soporte para interfaz grfica.\n"
#define MSGTR_GuiNeedsX "La interfaz grfica de MPlayer requiere X11!\n"
#define MSGTR_Playing "Reproduccin %s\n"
#define MSGTR_NoSound "Audio: sin sonido.\n"
#define MSGTR_FPSforced "FPS forzado en %5.3f  (ftime: %5.3f)\n"

#define MSGTR_CompiledWithRuntimeDetection "Compilado con deteccin RUNTIME CPU - esto no es ptimo! Para tener mejor rendimiento, recompila MPlayer con --disable-runtime-cpudetection.\n"
#define MSGTR_CompiledWithCPUExtensions "Compilado para CPU x86 con extensiones:"
#define MSGTR_AvailableVideoOutputPlugins "Plugins de salida de vdeo disponibles:\n"
#define MSGTR_AvailableVideoOutputDrivers "Drivers de salida de vdeo disponibles:\n"
#define MSGTR_AvailableAudioOutputDrivers "Drivers de salida de audio disponibles:\n"
#define MSGTR_AvailableAudioCodecs "Codecs de audio disponibles:\n"
#define MSGTR_AvailableVideoCodecs "Codecs de vdeo disponibles:\n"
#define MSGTR_AvailableAudioFm "\nFamilias/drivers de codecs de audio (compilados dentro de MPlayer) disponibles:\n"
#define MSGTR_AvailableVideoFm "\nFamilias/drivers de codecs de vdeo (compilados dentro de MPlayer) disponibles:\n"
#define MSGTR_AvailableFsType "Modos disponibles de cambio a pantalla completa:\n"
#define MSGTR_UsingRTCTiming "Usando el RTC timing por hardware de Linux (%ldHz).\n"
#define MSGTR_CannotReadVideoProperties "Vdeo: no se puede leer las propiedades.\n"
#define MSGTR_NoStreamFound "No se ha encontrado stream.\n"
#define MSGTR_InitializingAudioCodec "Inicializando codec de audio...\n"
#define MSGTR_ErrorInitializingVODevice "Error abriendo/inicializando el dispositivo de la salida de vdeo (-vo)!\n"
#define MSGTR_ForcedVideoCodec "Forzado el codec de vdeo: %s.\n"
#define MSGTR_ForcedAudioCodec "Forzado el codec de audio: %s\n"
#define MSGTR_AODescription_AOAuthor "AO: Descripcin: %s\nAO: Autor: %s.\n"
#define MSGTR_AOComment "AO: Comentario: %s.\n"
#define MSGTR_Video_NoVideo "Vdeo: no hay vdeo!\n"
#define MSGTR_NotInitializeVOPorVO "\nFATAL: No se pudieron inicializar los filtros de vdeo (-vop) o de salida de vdeo (-vo)!\n"
#define MSGTR_Paused "\n  =====  PAUSA  =====\r"
#define MSGTR_PlaylistLoadUnable "\nNo se puede cargar la lista de reproduccin %s.\n"
#define MSGTR_Exit_SIGILL_RTCpuSel \
"- MPlayer se detuvo por una 'Instruccin Ilegal'.\n"\
"  Esto puede ser un defecto en nuestra rutina nueva de autodeteccin de CPU...\n"\
"  Por favor lee DOCS/bugreports.html.\n"
#define MSGTR_Exit_SIGILL \
"- MPlayer se detuvo por una 'Instruccin Ilegal'.\n"\
"  Esto ocurre normalmente cuando ejecuta el programa en una CPU diferente de\n"\
"  la cual MPlayer fue compilado/optimizado.\n  Verifica eso!\n"
#define MSGTR_Exit_SIGSEGV_SIGFPE \
"- MPlayer se detuvo por mal uso de CPU/FPU/RAM.\n"\
"  Recompila MPlayer con la opcin --enable-debug y hace un backtrace en 'gdb' y\n"\
"  un desensamblado. Para ms detalles, vea DOCS/bugreports.html#crash.b.\n"
#define MSGTR_Exit_SIGCRASH \
"- MPlayer se detuvo. Esto no debera haber pasado.\n"\
"  Puede ser un defecto en el cdigo de MPlayer _o_ en sus drivers _o_ en su versin\n"\
"  de gcc. Si piensa que es la culpa de MPlayer, por favor lea DOCS/bugreports.html\n"\
"  y siga las instrucciones que all se encuentran. No podemos y no lo ayudaremos a\n"\
"  menos que nos provea esa informacin cuando este reportando algn posible defecto.\n"

// mencoder.c:

#define MSGTR_UsingPass3ControllFile "Usando el archivo de control pass3: %s\n"
#define MSGTR_MissingFilename "\nFalta el nombre del archivo.\n\n"
#define MSGTR_CannotOpenFile_Device "No se pudo abrir el archivo o el dispositivo.\n"
#define MSGTR_ErrorDVDAuth "Error en la autorizacin DVD...\n"
#define MSGTR_CannotOpenDemuxer "No se pudo abrir el demuxer.\n"
#define MSGTR_NoAudioEncoderSelected "\nNo se ha seleccionado codificador de audio (-oac)! Escoge uno usando -oac help, o usa -nosound.\n"
#define MSGTR_NoVideoEncoderSelected "\nNo se ha seleccionado codificador de video (-ovc)! Escoge uno usando -ovc help!\n"
#define MSGTR_InitializingAudioCodec "Inicializando codec de audio...\n"
#define MSGTR_CannotOpenOutputFile "No se puede abrir el archivo de salida'%s'.\n"
#define MSGTR_EncoderOpenFailed "No se pudo abrir el codificador.\n"
#define MSGTR_ForcingOutputFourcc "Forzando salida fourcc a %x [%.4s].\n"
#define MSGTR_WritingAVIHeader "Escribiendo cabecera AVI...\n"
#define MSGTR_DuplicateFrames "\n%d frame(s) duplicados.\n"
#define MSGTR_SkipFrame "\nse salta frame...\n"
#define MSGTR_ErrorWritingFile "%s: error escribiendo el archivo.\n"
#define MSGTR_WritingAVIIndex "\nEscribiendo index AVI...\n"
#define MSGTR_FixupAVIHeader "Arreglando cabecera AVI..\n"
#define MSGTR_RecommendedVideoBitrate "Bitrate recomendado para %s CD: %d.\n"
#define MSGTR_VideoStreamResult "\nStream de vdeo: %8.3f kbit/s (%d bps), tamao: %d bytes, %5.3f segundos, %d frames\n"
#define MSGTR_AudioStreamResult "\nStream de audio: %8.3f kbit/s (%d bps), tamao: %d bytes, %5.3f segundos\n"

// cfg-mencoder.h

#define MSGTR_MEncoderMP3LameHelp "\n\n"\
" vbr=<0-4>     mtodo de tasa de bits variable\n"\
"                0: cbr\n"\
"                1: mt\n"\
"                2: rh(default)\n"\
"                3: abr\n"\
"                4: mtrh\n"\
"\n"\
" abr           tasa de bits media\n"\
"\n"\
" cbr           tasa de bits constante\n"\
"               Forzar tambin modo de codificacin CBR en modos ABR \n"\
"               preseleccionados subsecuentemente\n"\
"\n"\
" br=<0-1024>   especifica tasa de bits en kBit (solo CBR y ABR)\n"\
"\n"\
" q=<0-9>       calidad (0-mejor, 9-peor) (solo para VBR)\n"\
"\n"\
" aq=<0-9>      calidad del algoritmo (0-mejor/lenta, 9-peor/rpida)\n"\
"\n"\
" ratio=<1-100> razn de compresin\n"\
"\n"\
" vol=<0-10>    configura ganancia de entrada de audio\n"\
"\n"\
" mode=<0-3>    (por defecto: auto)\n"\
"                0: estreo\n"\
"                1: estreo-junto\n"\
"                2: canal dual\n"\
"                3: mono\n"\
"\n"\
" padding=<0-2>\n"\
"                0: no\n"\
"                1: todo\n"\
"                2: ajustar\n"\
"\n"\
" fast          activa codificacin rpida en modos VBR preseleccionados\n"\
"               subsecuentes, ms baja calidad y tasas de bits ms altas.\n"\
"\n"\
" preset=<value> provee configuracion con la mejor calidad posible.\n"\
"                 medium: codificacin VBR, buena calidad\n"\
"                 (rango de 150-180 kbps de tasa de bits)\n"\
"                 standard:  codificacin VBR, alta calidad\n"\
"                 (rango de 170-210 kbps de tasa de bits)\n"\
"                 extreme: codificacin VBR, muy alta calidad\n"\
"                 (rango de 200-240 kbps de tasa de bits)\n"\
"                 insane:  codificacin CBR, la mejor calidad configurable\n"\
"                 (320 kbps de tasa de bits)\n"\
"                 <8-320>: codificacin ABR con tasa de bits en promedio en los kbps dados.\n\n"

// open.c, stream.c:
#define MSGTR_CdDevNotfound "Dispositivo de CD-ROM '%s' no encontrado.\n"
#define MSGTR_ErrTrackSelect "Error seleccionando la pista de VCD!"
#define MSGTR_ReadSTDIN "Leyendo desde la entrada estndar (stdin)...\n"
#define MSGTR_UnableOpenURL "No se puede abrir URL: %s\n"
#define MSGTR_ConnToServer "Connectado al servidor: %s\n"
#define MSGTR_FileNotFound "Archivo no encontrado: '%s'\n"

#define MSGTR_SMBInitError "No se puede inicializar la librera libsmbclient: %d\n"
#define MSGTR_SMBFileNotFound "No se puede abrir desde la red: '%s'\n"
#define MSGTR_SMBNotCompiled "MPlayer no fue compilado con soporte de lectura de SMB\n"

#define MSGTR_CantOpenDVD "No se puede abrir el dispositivo de DVD: %s\n"
#define MSGTR_DVDwait "Leyendo la estructura del disco, espere por favor...\n"
#define MSGTR_DVDnumTitles "Hay %d ttulos en este DVD.\n"
#define MSGTR_DVDinvalidTitle "Nmero de ttulo de DVD invlido: %d\n"
#define MSGTR_DVDnumChapters "Hay %d captulos en este ttulo de DVD.\n"
#define MSGTR_DVDinvalidChapter "Nmero de captulo de DVD invlido: %d\n"
#define MSGTR_DVDnumAngles "Hay %d ngulos en este ttulo de DVD.\n"
#define MSGTR_DVDinvalidAngle "Nmero de ngulo de DVD invlido: %d\n"
#define MSGTR_DVDnoIFO "No se puede abrir archivo IFO para el ttulo de DVD %d.\n"
#define MSGTR_DVDnoVOBs "No se puede abrir VOBS del ttulo (VTS_%02d_1.VOB).\n"
#define MSGTR_DVDopenOk "DVD abierto.\n"

// demuxer.c, demux_*.c:
#define MSGTR_AudioStreamRedefined "Advertencia! Cabecera de stream de audio %d redefinida!\n"
#define MSGTR_VideoStreamRedefined "Advertencia! Cabecera de stream de video %d redefinida!\n"
#define MSGTR_TooManyAudioInBuffer "\nDEMUXER: Demasiados (%d en %d bytes) paquetes de audio en el buffer!\n"
#define MSGTR_TooManyVideoInBuffer "\nDEMUXER: Demasiados (%d en %d bytes) paquetes de video en el buffer!\n"
#define MSGTR_MaybeNI "Ests reproduciendo un stream o archivo 'non-interleaved' o fall el codec?\n " \
		"Para archivos .AVI, intente forzar el modo 'non-interleaved' con la opcin -ni.\n"
#define MSGTR_SwitchToNi "\nDetectado .AVI mal interleaveado - cambiando al modo -ni!\n"
#define MSGTR_Detected_XXX_FileFormat "Detectado formato de archivo %s.\n"
#define MSGTR_DetectedAudiofile "Detectado archivo de audio.\n"
#define MSGTR_NotSystemStream "Esto no es formato MPEG System Stream... (tal vez Transport Stream?)\n"
#define MSGTR_InvalidMPEGES "Stream MPEG-ES invlido? Contacta con el autor, podra ser un fallo.\n"
#define MSGTR_FormatNotRecognized "Este formato no est soportado o reconocido. Si este archivo es un AVI, ASF o MPEG, por favor contacte con el autor.\n"
#define MSGTR_MissingVideoStream "No se encontr stream de video!\n"
#define MSGTR_MissingAudioStream "No se encontr el stream de audio, no se reproducir sonido.\n"
#define MSGTR_MissingVideoStreamBug "Stream de video perdido!? Contacta con el autor, podra ser un fallo.\n"

#define MSGTR_DoesntContainSelectedStream "demux: El archivo no contiene el stream de audio o video seleccionado.\n"

#define MSGTR_NI_Forced "Forzado"
#define MSGTR_NI_Detected "Detectado"
#define MSGTR_NI_Message "%s formato de AVI 'NON-INTERLEAVED'.\n"

#define MSGTR_UsingNINI "Usando formato de AVI roto 'NON-INTERLEAVED'.\n"
#define MSGTR_CouldntDetFNo "No se puede determinar el nmero de frames (para una bsqueda absoluta).\n"
#define MSGTR_CantSeekRawAVI "No se puede avanzar o retroceder en un stream crudo .AVI (se requiere ndice, prueba con -idx).\n"
#define MSGTR_CantSeekFile "No se puede avanzar o retroceder en este archivo.\n"

#define MSGTR_EncryptedVOB "Archivo VOB encriptado (no se compil con soporte de libcss). Lee DOCS/cd-dvd.html.\n"
#define MSGTR_EncryptedVOBauth "Stream encriptado pero no pediste autenticacin.\n"

#define MSGTR_MOVcomprhdr "MOV: Cabecera comprimida no suportada (por ahora).\n"
#define MSGTR_MOVvariableFourCC "MOV: Advertencia. Variable FOURCC detectada!\n"
#define MSGTR_MOVtooManyTrk "MOV: Advertencia. Demasiadas pistas!"
#define MSGTR_FoundAudioStream "==> Encontrado stream de audio: %d\n"
#define MSGTR_FoundVideoStream "==> Encontrado stream de vdeo: %d\n"
#define MSGTR_DetectedTV "Detectado TV.\n"
#define MSGTR_ErrorOpeningOGGDemuxer "No se puede abrir el demuxer ogg.\n"
#define MSGTR_ASFSearchingForAudioStream "ASF: Buscando stream de audio (id:%d)\n"
#define MSGTR_CannotOpenAudioStream "No se puede abrir stream de audio: %s\n"
#define MSGTR_CannotOpenSubtitlesStream "No se puede abrir stream de subttulos: %s\n"
#define MSGTR_OpeningAudioDemuxerFailed "No se pudo abrir el demuxer de audio: %s\n"
#define MSGTR_OpeningSubtitlesDemuxerFailed "No se pudo abrir demuxer de subttulos: %s\n"
#define MSGTR_TVInputNotSeekable "Entrada de TV no es buscable.\n"
#define MSGTR_DemuxerInfoAlreadyPresent "Informacin de demuxer %s ya est disponible.\n"
#define MSGTR_ClipInfo "Informacin de clip: \n"

#define MSGTR_LeaveTelecineMode "\ndemux_mpg: Secuencia progresiva detectada, dejando modo 3:2 TELECINE\n"
#define MSGTR_EnterTelecineMode "\ndemux_mpg: modo 3:2 TELECINE detectado, habilitando telecine fx inverso. Cuadros por segundo cambiado a %5.3f!  \n"

// dec_video.c & dec_audio.c:
#define MSGTR_CantOpenCodec "No se pudo abrir codec.\n"
#define MSGTR_CantCloseCodec "No se pudo cerrar codec.\n"

#define MSGTR_MissingDLLcodec "ERROR: No se pudo abrir el codec DirectShow requerido: %s\n"
#define MSGTR_ACMiniterror "No se puede cargar/inicializar codecs de audio Win32/ACM (falta archivo DLL?)\n"
#define MSGTR_MissingLAVCcodec "No se encuentra codec '%s' en libavcodec...\n"


#define MSGTR_MpegNoSequHdr "MPEG: FATAL: EOF mientras buscaba la cabecera de secuencia.\n"
#define MSGTR_CannotReadMpegSequHdr "FATAL: No se puede leer cabecera de secuencia.\n"
#define MSGTR_CannotReadMpegSequHdrEx "FATAL: No se puede leer la extensin de la cabecera de secuencia.\n"
#define MSGTR_BadMpegSequHdr "MPEG: Mala cabecera de secuencia.\n"
#define MSGTR_BadMpegSequHdrEx "MPEG: Mala extensin de la cabecera de secuencia.\n"

#define MSGTR_ShMemAllocFail "No se puede alocar memoria compartida.\n"
#define MSGTR_CantAllocAudioBuf "No se puede alocar buffer de la salida de audio.\n"
#define MSGTR_UnknownAudio "Formato de audio desconocido/perdido, no se reproducir sonido.\n"


#define MSGTR_UsingExternalPP "[PP] Usando filtro de postprocesado externo, max q = %d.\n"
#define MSGTR_UsingCodecPP "[PP] Usando postprocesado del codec, max q = %d.\n"
#define MSGTR_VideoAttributeNotSupportedByVO_VD "Atributo de vdeo '%s' no es soportado por -vo y -vd actuales. \n"
#define MSGTR_VideoCodecFamilyNotAvailableStr "Familia de codec de vdeo solicitada [%s] (vfm=%s) no est disponible (actvalo al compilar).\n"
#define MSGTR_AudioCodecFamilyNotAvailableStr "Familia de codec de audio solicitada [%s] (afm=%s) no est disponible (actvalo al compilar).\n"
#define MSGTR_OpeningVideoDecoder "Abriendo descodificador de vdeo: [%s] %s.\n"
#define MSGTR_OpeningAudioDecoder "Abriendo descodificador de audio: [%s] %s.\n"
#define MSGTR_UninitVideoStr "uninit video: %s.\n"
#define MSGTR_UninitAudioStr "uninit audio: %s.\n"
#define MSGTR_VDecoderInitFailed "Inicializacin del VDecoder ha fallado.\n"
#define MSGTR_ADecoderInitFailed "Inicializacin del ADecoder ha fallado.\n"
#define MSGTR_ADecoderPreinitFailed "Preinicializacin del ADecoder ha fallado.\n"
#define MSGTR_AllocatingBytesForInputBuffer "dec_audio: Alocando %d bytes para el bfer de entrada.\n"
#define MSGTR_AllocatingBytesForOutputBuffer "dec_audio: Allocating %d + %d = %d bytes para el bfer de salida.\n"


// LIRC:
#define MSGTR_SettingUpLIRC "Configurando soporte para LIRC...\n"
#define MSGTR_LIRCdisabled "No podrs usar el control remoto.\n"
#define MSGTR_LIRCopenfailed "Fallo al abrir el soporte para LIRC.\n"
#define MSGTR_LIRCcfgerr "Fallo al leer archivo de configuracin de LIRC %s.\n"


// vf.c
#define MSGTR_CouldNotFindVideoFilter "No se pudo encontrar el filtro de vdeo '%s'.\n"
#define MSGTR_CouldNotOpenVideoFilter "No se pudo abrir el filtro de vdeo '%s'.\n"
#define MSGTR_OpeningVideoFilter "Abriendo filtro de vdeo: "
#define MSGTR_CannotFindColorspace "No se pudo encontrar colorspace comn, tampoco insertando 'scale'.\n"

// vd.c
#define MSGTR_CodecDidNotSet "VDec: el codec no declar sh->disp_w y sh->disp_h, intentando solucionarlo!\n"
#define MSGTR_VoConfigRequest "VDec: vo solicitud de config - %d x %d (csp preferida: %s).\n"
#define MSGTR_CouldNotFindColorspace "No se pudo encontrar colorspace comn - reintentando escalado -vop...\n"
#define MSGTR_MovieAspectIsSet "Aspecto es %.2f:1 - prescalando a aspecto correcto.\n"
#define MSGTR_MovieAspectUndefined "Aspecto de pelcula no es definido - no se ha aplicado prescalado.\n"


// ====================== GUI messages/buttons ========================

#ifdef HAVE_NEW_GUI

// --- labels ---
#define MSGTR_About "Acerca de"
#define MSGTR_FileSelect "Seleccionar archivo ..."
#define MSGTR_SubtitleSelect "Seleccionar subttulos ..."
#define MSGTR_OtherSelect "Seleccionar ..."
#define MSGTR_AudioFileSelect "Seleccionar canal de audio externo ..."
#define MSGTR_FontSelect "Seleccionar fuente ..."
#define MSGTR_PlayList "Lista de reproduccin"
#define MSGTR_Equalizer "Equalizador"
#define MSGTR_SkinBrowser "Navegador de skins"
#define MSGTR_Network "Streaming por red ..."
#define MSGTR_Preferences "Preferencias"
#define MSGTR_OSSPreferences "Configuracin del driver OSS"
#define MSGTR_SDLPreferences "Configuracin del driver SDL"
#define MSGTR_NoMediaOpened "no se abri audio/vdeo"
#define MSGTR_VCDTrack "pista VCD %d"
#define MSGTR_NoChapter "sin captulo"
#define MSGTR_Chapter "captulo %d"
#define MSGTR_NoFileLoaded "no se ha cargado ningn archivo"


// --- buttons ---
#define MSGTR_Ok "Ok"
#define MSGTR_Cancel "Cancelar"
#define MSGTR_Add "Agregar"
#define MSGTR_Remove "Quitar"
#define MSGTR_Clear "Limpiar"
#define MSGTR_Config "Configurar"
#define MSGTR_ConfigDriver "Configurar driver"
#define MSGTR_Browse "Navegar"

// --- error messages ---
#define MSGTR_NEMDB "No hay suficiente memoria para dibujar el bfer."
#define MSGTR_NEMFMR "No hay suficiente memoria para dibujar el men."
#define MSGTR_IDFGCVD "No se encuentra driver -vo compatible con la interfaz grfica."
#define MSGTR_NEEDLAVCFAME "No puede reproducir archivos no MPEG con su DXR3/H+ sin recodificacin. Activa lavc o fame en la configuracin del DXR3/H+."

// --- skin loader error messages
#define MSGTR_SKIN_ERRORMESSAGE "[skin] error en configuracin de skin en la lnea %d: %s"
#define MSGTR_SKIN_WARNING1 "[skin] advertencia en configuracin de skin en la lnea %d: widget encontrado pero \"section\" posterior no encontrada ( %s )"
#define MSGTR_SKIN_WARNING2 "[skin] advertencia en configuracin de skin en la lnea %d: widget encontrado pero \"subsection\" posterior no encontrada (%s)"
#define MSGTR_SKIN_WARNING3 "[skin] advertencia en configuracin de skin en la linea %d: subsection no suportada por widget (%s)"
#define MSGTR_SKIN_BITMAP_16bit  "Mapa de bits de 16 bits o menos no soportado ( %s ).\n"
#define MSGTR_SKIN_BITMAP_FileNotFound  "Archivo no encontrado ( %s ).\n"
#define MSGTR_SKIN_BITMAP_BMPReadError "Error al leer bmp ( %s ).\n"
#define MSGTR_SKIN_BITMAP_TGAReadError "Error al leer tga ( %s ).\n"
#define MSGTR_SKIN_BITMAP_PNGReadError "Error al leer png ( %s ).\n"
#define MSGTR_SKIN_BITMAP_RLENotSupported "RLE packed tga no soportado ( %s ).\n"
#define MSGTR_SKIN_BITMAP_UnknownFileType "Tipo de archivo desconocido ( %s ).\n"
#define MSGTR_SKIN_BITMAP_ConvertError "Error de conversin de 24 bit a 32 bit ( %s ).\n"
#define MSGTR_SKIN_BITMAP_UnknownMessage "Mensaje desconocido: %s.\n"
#define MSGTR_SKIN_FONT_NotEnoughtMemory "No hay suficiente memoria.\n"
#define MSGTR_SKIN_FONT_TooManyFontsDeclared "Demasiadas fuentes declaradas.\n"
#define MSGTR_SKIN_FONT_FontFileNotFound "Archivo de fuentes no encontrado.\n"
#define MSGTR_SKIN_FONT_FontImageNotFound "Archivo de imagen de fuente noi encontrado.\n"
#define MSGTR_SKIN_FONT_NonExistentFontID "Identificador de fuente no existente ( %s ).\n"
#define MSGTR_SKIN_UnknownParameter "Parmetro desconocido ( %s ).\n"
#define MSGTR_SKINBROWSER_NotEnoughMemory "[skinbrowser] no hay suficiente memoria.\n"
#define MSGTR_SKIN_SKINCFG_SkinNotFound "Skin no encontrado( %s ).\n"
#define MSGTR_SKIN_SKINCFG_SkinCfgReadError "Error de lectura de la configuracin del skin ( %s ).\n"
#define MSGTR_SKIN_LABEL "Skins:"

// --- gtk menus
#define MSGTR_MENU_AboutMPlayer "Sobre MPlayer"
#define MSGTR_MENU_Open "Abrir ..."
#define MSGTR_MENU_PlayFile "Reproducir archivo ..."
#define MSGTR_MENU_PlayVCD "Reproducir VCD ..."
#define MSGTR_MENU_PlayDVD "Reproducir DVD ..."
#define MSGTR_MENU_PlayURL "Reproducir URL ..."
#define MSGTR_MENU_DropSubtitle "Cancelar subtitulos ..."
#define MSGTR_MENU_LoadSubtitle "Cargar subttulos ..."
#define MSGTR_MENU_LoadExternAudioFile "Cargar archivo de audio externo ..."
#define MSGTR_MENU_Playing "Reproduciendo"
#define MSGTR_MENU_Play "Reproducir"
#define MSGTR_MENU_Pause "Pausa"
#define MSGTR_MENU_Stop "Parar"
#define MSGTR_MENU_NextStream "Siguiente stream"
#define MSGTR_MENU_PrevStream "Anterior stream"
#define MSGTR_MENU_Size "Tamao"
#define MSGTR_MENU_NormalSize "Tamao normal"
#define MSGTR_MENU_DoubleSize "Tamao doble"
#define MSGTR_MENU_FullScreen "Pantalla completa"
#define MSGTR_MENU_DVD "DVD"
#define MSGTR_MENU_VCD "VCD"
#define MSGTR_MENU_PlayDisc "Reproducir disco ..."
#define MSGTR_MENU_ShowDVDMenu "Mostrar men DVD"
#define MSGTR_MENU_Titles "Ttulos"
#define MSGTR_MENU_Title "Ttulo %2d"
#define MSGTR_MENU_None "(ninguno)"
#define MSGTR_MENU_Chapters "Captulos"
#define MSGTR_MENU_Chapter "Captulo %2d"
#define MSGTR_MENU_AudioLanguages "Idiomas de audio"
#define MSGTR_MENU_SubtitleLanguages "Idiomas de subttulos"
#define MSGTR_MENU_PlayList "Lista de reproduccin"
#define MSGTR_MENU_SkinBrowser "Navegador de skins"
#define MSGTR_MENU_Preferences "Preferencias"
#define MSGTR_MENU_Exit "Salir"
#define MSGTR_MENU_Mute "Mudo"
#define MSGTR_MENU_Original "Original"
#define MSGTR_MENU_AspectRatio "Relacin de aspecto"
#define MSGTR_MENU_AudioTrack "Pista de Audio"
#define MSGTR_MENU_Track "Pista %d"
#define MSGTR_MENU_VideoTrack "Pista de Video"


// --- equalizer
#define MSGTR_EQU_Audio "Audio"
#define MSGTR_EQU_Video "Video"
#define MSGTR_EQU_Contrast "Contraste: "
#define MSGTR_EQU_Brightness "Brillo: "
#define MSGTR_EQU_Hue "Hue: "
#define MSGTR_EQU_Saturation "Saturacin: "
#define MSGTR_EQU_Front_Left "Frente izquierdo"
#define MSGTR_EQU_Front_Right "Frente derecho"
#define MSGTR_EQU_Back_Left "Fondo izquierdo"
#define MSGTR_EQU_Back_Right "Fondo dercho"
#define MSGTR_EQU_Center "Centro"
#define MSGTR_EQU_Bass "Bajo"
#define MSGTR_EQU_All "Todos"
#define MSGTR_EQU_Channel1 "Canal 1:"
#define MSGTR_EQU_Channel2 "Canal 2:"
#define MSGTR_EQU_Channel3 "Canal 3:"
#define MSGTR_EQU_Channel4 "Canal 4:"
#define MSGTR_EQU_Channel5 "Canal 5:"
#define MSGTR_EQU_Channel6 "Canal 6:"

// --- playlist
#define MSGTR_PLAYLIST_Path "Ubicacin"
#define MSGTR_PLAYLIST_Selected "Archivos seleccionados"
#define MSGTR_PLAYLIST_Files "Archivos"
#define MSGTR_PLAYLIST_DirectoryTree "rbol de directorios"

// --- preferences
#define MSGTR_PREFERENCES_Audio "Audio"
#define MSGTR_PREFERENCES_Video "Vdeo"
#define MSGTR_PREFERENCES_SubtitleOSD "Subttulos y OSD"
#define MSGTR_PREFERENCES_Codecs "Codecs y demuxer"
#define MSGTR_PREFERENCES_Misc "Misc"

#define MSGTR_PREFERENCES_None "Ninguno"
#define MSGTR_PREFERENCES_AvailableDrivers "Drivers disponibles:"
#define MSGTR_PREFERENCES_DoNotPlaySound "No reproducir sonido"
#define MSGTR_PREFERENCES_NormalizeSound "Normalizar sonido"
#define MSGTR_PREFERENCES_EnEqualizer "Activar equalizer"
#define MSGTR_PREFERENCES_ExtraStereo "Activar estereo extra"
#define MSGTR_PREFERENCES_Coefficient "Coeficiente:"
#define MSGTR_PREFERENCES_AudioDelay "Retraso de audio"
#define MSGTR_PREFERENCES_DoubleBuffer "Activar buffering doble"
#define MSGTR_PREFERENCES_DirectRender "Activar renderizacin directa"
#define MSGTR_PREFERENCES_FrameDrop "Activar frame dropping"
#define MSGTR_PREFERENCES_HFrameDrop "Activar frame dropping DURO (peligroso)"
#define MSGTR_PREFERENCES_Flip "Visualizar imagen al revs"
#define MSGTR_PREFERENCES_Panscan "Panscan: "
#define MSGTR_PREFERENCES_OSDTimer "Timer e indicadores"
#define MSGTR_PREFERENCES_OSDProgress "Slo barra de progreso"
#define MSGTR_PREFERENCES_OSDTimerPercentageTotalTime "Timer, porcentaje y tiempo total"
#define MSGTR_PREFERENCES_Subtitle "Subttulo:"
#define MSGTR_PREFERENCES_SUB_Delay "Retraso: "
#define MSGTR_PREFERENCES_SUB_FPS "FPS:"
#define MSGTR_PREFERENCES_SUB_POS "Posicin: "
#define MSGTR_PREFERENCES_SUB_AutoLoad "Desactivar carga automtica de subttulos"
#define MSGTR_PREFERENCES_SUB_Unicode "Subttulo unicode"
#define MSGTR_PREFERENCES_SUB_MPSUB "Convertir el subttulo dado al formato de subttulos de MPlayer"
#define MSGTR_PREFERENCES_SUB_SRT "Convertir el subttulo dado al formato basado en tiempo SubViewer (SRT)"
#define MSGTR_PREFERENCES_SUB_Overlap "Superposicin de subtitulos"
#define MSGTR_PREFERENCES_Font "Fuente:"
#define MSGTR_PREFERENCES_FontFactor "Factor de fuente:"
#define MSGTR_PREFERENCES_PostProcess "Activar postprocesado"
#define MSGTR_PREFERENCES_AutoQuality "Calidad automtica: "
#define MSGTR_PREFERENCES_NI "Usar non-interleaved AVI parser"
#define MSGTR_PREFERENCES_IDX "Reconstruir tabla de indices, si se necesita"
#define MSGTR_PREFERENCES_VideoCodecFamily "Familia de codec de vdeo:"
#define MSGTR_PREFERENCES_AudioCodecFamily "Familia de codec de audio:"
#define MSGTR_PREFERENCES_FRAME_OSD_Level "Nivel OSD"
#define MSGTR_PREFERENCES_FRAME_Subtitle "Subttulos"
#define MSGTR_PREFERENCES_FRAME_Font "Fuente"
#define MSGTR_PREFERENCES_FRAME_PostProcess "Postprocesado"
#define MSGTR_PREFERENCES_FRAME_CodecDemuxer "Codec y demuxer"
#define MSGTR_PREFERENCES_FRAME_Cache "Cache"
#define MSGTR_PREFERENCES_FRAME_Misc "Misc"
#define MSGTR_PREFERENCES_OSS_Device "Dispositivo:"
#define MSGTR_PREFERENCES_OSS_Mixer "Mezclador:"
#define MSGTR_PREFERENCES_SDL_Driver "Controlador:"
#define MSGTR_PREFERENCES_Message "Algunas opciones requieren reiniciar la reproduccin."
#define MSGTR_PREFERENCES_DXR3_VENC "Codificador de vdeo:"
#define MSGTR_PREFERENCES_DXR3_LAVC "Usar LAVC (ffmpeg)"
#define MSGTR_PREFERENCES_DXR3_FAME "Usar FAME"
#define MSGTR_PREFERENCES_FontEncoding1 "Unicode"
#define MSGTR_PREFERENCES_FontEncoding2 "Occidental (ISO-8859-1)"
#define MSGTR_PREFERENCES_FontEncoding3 "Occidental con euro (ISO-8859-15)"
#define MSGTR_PREFERENCES_FontEncoding4 "Centroeuropeo (ISO-8859-2)"
#define MSGTR_PREFERENCES_FontEncoding5 "Esperanto, Gallego, Malts, Turco (ISO-8859-3)"
#define MSGTR_PREFERENCES_FontEncoding6 "Bltico (ISO-8859-4)"
#define MSGTR_PREFERENCES_FontEncoding7 "Cirlico (ISO-8859-5)"
#define MSGTR_PREFERENCES_FontEncoding8 "rabe (ISO-8859-6)"
#define MSGTR_PREFERENCES_FontEncoding9 "Griego moderno (ISO-8859-7)"
#define MSGTR_PREFERENCES_FontEncoding10 "Turco (ISO-8859-9)"
#define MSGTR_PREFERENCES_FontEncoding11 "Bltico (ISO-8859-13)"
#define MSGTR_PREFERENCES_FontEncoding12 "Cltico (ISO-8859-14)"
#define MSGTR_PREFERENCES_FontEncoding13 "Hebreo (ISO-8859-8)"
#define MSGTR_PREFERENCES_FontEncoding14 "Ruso (KOI8-R)"
#define MSGTR_PREFERENCES_FontEncoding15 "Belaruso (KOI8-U/RU)"
#define MSGTR_PREFERENCES_FontEncoding16 "Chino simplificado (CP936)"
#define MSGTR_PREFERENCES_FontEncoding17 "Chino tradicional (BIG5)"
#define MSGTR_PREFERENCES_FontEncoding18 "Japans(SHIFT-JIS)"
#define MSGTR_PREFERENCES_FontEncoding19 "Coreano (CP949)"
#define MSGTR_PREFERENCES_FontEncoding20 "Thai (CP874)"
#define MSGTR_PREFERENCES_FontEncoding21 "Cirlico (Windows) (CP1251)"
#define MSGTR_PREFERENCES_FontNoAutoScale "Sin autoescalado"
#define MSGTR_PREFERENCES_FontPropWidth "Proporcional a la anchura de pelcula"
#define MSGTR_PREFERENCES_FontPropHeight "Proporcional a la altura de pelcula"
#define MSGTR_PREFERENCES_FontPropDiagonal "Proporcional al diagonal de pelcula"
#define MSGTR_PREFERENCES_FontEncoding "Codificacin:"
#define MSGTR_PREFERENCES_FontBlur "Blur:"
#define MSGTR_PREFERENCES_FontOutLine "Outline:"
#define MSGTR_PREFERENCES_FontTextScale "Escalado de texto:"
#define MSGTR_PREFERENCES_FontOSDScale "Escalado de OSD:"
#define MSGTR_PREFERENCES_SubtitleOSD "Subttulos y OSD"
#define MSGTR_PREFERENCES_Cache "Cache si/no"
#define MSGTR_PREFERENCES_CacheSize "Tamao de Cache: "
#define MSGTR_PREFERENCES_LoadFullscreen "Empezar en pantalla completa"
#define MSGTR_PREFERENCES_XSCREENSAVER "Detener Salvador de Pantallas de X"
#define MSGTR_PREFERENCES_PlayBar "Habilitar barra de reproduccin"
#define MSGTR_PREFERENCES_AutoSync "AutoSync si/no"
#define MSGTR_PREFERENCES_AutoSyncValue "Autosync: "
#define MSGTR_PREFERENCES_CDROMDevice "Dispositivo de CD-ROM:"
#define MSGTR_PREFERENCES_DVDDevice "Dispositivo de DVD:"
#define MSGTR_PREFERENCES_FPS "Cuadros por segundo de la Pelicula:"
#define MSGTR_PREFERENCES_ShowVideoWindow "Mostrar ventana de video cuando este inactiva"

#define MSGTR_ABOUT_UHU " Desarrollo de GUI patrocinado por UHU Linux\n"
#define MSGTR_ABOUT_CoreTeam "   Equipo principal de MPlayer:\n"
#define MSGTR_ABOUT_AdditionalCoders "   Otros programadores:\n"
#define MSGTR_ABOUT_MainTesters "   Testeadores ms importantes:\n"

// --- messagebox
#define MSGTR_MSGBOX_LABEL_FatalError "Error fatal"
#define MSGTR_MSGBOX_LABEL_Error "Error"
#define MSGTR_MSGBOX_LABEL_Warning "Advertencia"

#endif
